package extnet

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// DeviceMigrateRequest struct for migrate VNF
type DeviceMigrateRequest struct {
	// ID of external network
	// Required: true
	NetID uint64 `url:"net_id" json:"net_id" validate:"required"`

	// Target node ID to migrate to
	// Required: false
	NodeID uint64 `url:"node_id,omitempty" json:"node_id,omitempty"`

	// Target device to migrate
	// Required: false
	// Default: primary
	Device string `url:"device,omitempty" json:"device,omitempty" validate:"omitempty,device"`
}

// DeviceMigrate migrates external network VNF device
func (e ExtNet) DeviceMigrate(ctx context.Context, req DeviceMigrateRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/extnet/deviceMigrate"

	res, err := e.client.DecortApiCall(ctx, http.MethodPost, url, req)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}
